<?php

/*
 * @copyright Copyright (c) 2024 WinderNet
 *
 * @license MIT License
 *
 * @link https://gitlab.com/windernet/php/framework-module-common/-/blob/main/LICENSE
 */

//**************************************************************************************************************************************************\\
//                                                                                                                                                  \\
//                                                                     NAMESPACE                                                                    \\
//                                                                                                                                                  \\
//**************************************************************************************************************************************************\\

namespace WinderNet\Common;

//**************************************************************************************************************************************************\\
//                                                                                                                                                  \\
//                                                                      USAGES                                                                      \\
//                                                                                                                                                  \\
//**************************************************************************************************************************************************\\

use function realpath;

//**************************************************************************************************************************************************\\
//                                                                                                                                                  \\
//                                                                      CLASS                                                                       \\
//                                                                                                                                                  \\
//**************************************************************************************************************************************************\\

/**
 * This class provides functionalities regarding the application itself.
 *
 * @since 0.1.0
 */
class Application
{
    //**********************************************************************************************************************************************\\
    //                                                                                                                                              \\
    //                                                             APPLICATION FUNCTIONS                                                            \\
    //                                                                                                                                              \\
    //**********************************************************************************************************************************************\\

    /**
     * Gets the path to the application directory.
     *
     * @note The returned path will not have a trailing slash, unless it is the root directory.
     *
     * @return string - The path to the application directory.
     *
     * @since 0.1.0
     *
     * @example $applicationPath = Application::path();
     */
    public static function path(): string
    {
        return realpath(__DIR__ . '/../../../../');
    }
}
